/* Squirrel Script Tool for Simutrans
 * autor Andarix
 *
 * output mail overcrowded connected halts or all overcrowded halts
 * click on a stop to check connected stops or to click the map for all stops
 */

function init(pl)
{
	return true
}

function work(pl, pos)
{
	local output_message = ""

	local fs_tile = tile_x(pos.x, pos.y, pos.z)
	local stations_list = null
	local count = 0

	if ( fs_tile.get_halt() ) {
  	local stations_obj = fs_tile.get_halt()
		stations_list = stations_obj.get_connections(good_desc_x("Post"))
		//output_message += stations_list.len()
		if ( stations_list.len() > 0 ) {
			local mail_waiting = 0
			foreach(station in stations_list) {

				local list = station.get_connections(good_desc_x("Post"))
				if ( list.len() > 0 ) {
					foreach(target in list) {
						local tile_list = target.get_tile_list()
						mail_waiting += station.get_freight_to_dest(good_desc_x("Post"), tile_list[0])
						mail_waiting += station.get_freight_to_halt(good_desc_x("Post"), target)
					}

				}

				local tile_list = station.get_tile_list()
				if ( station.get_capacity(good_desc_x("Post")) < mail_waiting ) {
					count++
					output_message += "\n(" + "[" + mail_waiting + "] " + station.get_name() + " " + coord_to_string(square_x(tile_list[0].x, tile_list[0].y)) + ")"

				}
				mail_waiting = 0
			}
			if ( count == 0 ) {
				//output_message += translate("none")
			}
			output_message = format(translate("%s overcrowded connected halts from %s:"), translate("Post"), stations_obj.get_name()) + " (" + count + ")" + output_message

		} else {
			output_message += format(translate("no %s connected stops"), translate("Post"))
		}

	}	else {

		local mail_waiting = 0

    foreach(station in halt_list_x()) {

			if ( station.get_connections(good_desc_x("Post")).len() > 0 ) {
				local list = station.get_connections(good_desc_x("Post"))
				if ( list.len() > 0 ) {
					foreach(target in list) {
						local tile_list = target.get_tile_list()
						mail_waiting += station.get_freight_to_dest(good_desc_x("Post"), tile_list[0])
						mail_waiting += station.get_freight_to_halt(good_desc_x("Post"), target)
					}

				}

				if ( station.get_capacity(good_desc_x("Post")) < mail_waiting ) {
					count++
					local tile_list = station.get_tile_list()
					output_message += "\n(" + "[" + mail_waiting + "] " + station.get_name() + " " + coord_to_string(square_x(tile_list[0].x, tile_list[0].y)) + ")"

				}

				mail_waiting = 0
			}
    }
		if ( count == 0 ) {
			//output_message += translate("none")
		}
		output_message = format(translate("%s overcrowded world halts:"), translate("Post")) + " (" + count + ")" + output_message

	}

	return gui.add_message_at(player_x(1), output_message, world.get_time())
}

function exit(pl)
{
	return true
}