
function init(pl)
{
	return true
}

/**
 * return error message
 */
function work(pl, pos)
{

	local tile = tile_x(pos.x, pos.y, pos.z)
  local speed_old = null
  local wt = null

  if ( tile.find_object(mo_way) != null ) {
    speed_old = tile.find_object(mo_way).get_desc().get_topspeed()
    wt = tile.find_object(mo_way).get_desc().get_waytype()
  }

  if ( tile.is_bridge() ) {

    // check player
    if ( tile.find_object(mo_way) != null && tile.find_object(mo_way).get_owner().nr != pl.nr && tile.find_object(mo_way).get_owner().nr != 1 ) {
      local output_message = translate("Der Besitzer erlaubt das Entfernen nicht")
	    return gui.add_message_at(pl, output_message, world.get_time())
    }

    // find bridge start and end
    local d = tile.get_way_dirs(wt)

    local dir_x = (d == dir.east || d == dir.west || d == dir.eastwest) ? 1 : 0
    local dir_y = (d == dir.north || d == dir.south || d == dir.northsouth) ? 1 : 0

    local bridge_coord = []
    local catenary_coord = []
    local bridge_stations = []
    if ( tile.find_object(mo_building) != null && tile.is_bridge() ) { bridge_stations.append(tile) }

    local tile_a = tile
    local tile_b = tile

    local set_a = false
    local set_b = false

    do
    {

      if ( !set_a ) { tile_a = tile_x(tile_a.x - dir_x, tile_a.y - dir_y, tile_a.z) }
      if ( !set_b ) { tile_b = tile_x(tile_b.x + dir_x, tile_b.y + dir_y, tile_b.z) }

      if ( tile_a.find_object(mo_way) == null ) { tile_a = square_x(tile_a.x, tile_a.y).get_ground_tile() }
      if ( tile_b.find_object(mo_way) == null ) { tile_b = square_x(tile_b.x, tile_b.y).get_ground_tile() }

      if ( !tile_a.is_bridge() && !set_a ) {
        bridge_coord.append(square_x(tile_a.x + dir_x, tile_a.y + dir_y).get_ground_tile())
        tile = tile_a
        // coord for restor catenary
        catenary_coord.append(square_x(tile_a.x, tile_a.y).get_ground_tile())

        set_a = true
      }
      if ( !tile_b.is_bridge() && !set_b ) {
        bridge_coord.append(square_x(tile_b.x - dir_x, tile_b.y - dir_y).get_ground_tile())
        // coord for restor catenary
        catenary_coord.append(square_x(tile_b.x, tile_b.y).get_ground_tile())

        set_b = true
      }

      // check stations
      if ( tile_a.find_object(mo_building) != null && tile_a.is_bridge() ) { bridge_stations.append(tile_a) }
      if ( tile_b.find_object(mo_building) != null && tile_b.is_bridge() ) { bridge_stations.append(tile_b) }

    } while(bridge_coord.len()<2)

    //gui.add_message_at(pl, " bridge from " + coord3d_to_string(bridge_coord[0]) + " to " + coord3d_to_string(bridge_coord[1]), world.get_time())

    //gui.add_message_at(pl, " catenary from " + coord3d_to_string(tile_a) + " to " + coord3d_to_string(tile_b), world.get_time())

    // select new objects
    local speed = tile.find_object(mo_way).get_desc().get_topspeed()
    //gui.add_message_at(pl, coord3d_to_string(tile) + " speed  " + speed, world.get_time())
    //gui.add_message_at(pl, coord3d_to_string(tile) + " speed_old  " + speed_old, world.get_time())
    // way
    local way_obj = tile.find_object(mo_way).get_desc() //way_list[0]
    if ( !way_obj.is_available(world.get_time()) ) {
      way_obj = find_object("way", wt, way_obj.get_topspeed())
    }
    //gui.add_message_at(pl, " select way " + way_obj.get_name(), world.get_time())
    // catenary
    local catenary_obj = null
    if ( tile.find_object(mo_wayobj) != null ) {
      catenary_obj = tile.find_object(mo_wayobj).get_desc()
      if ( catenary_obj != null && !catenary_obj.is_available(world.get_time()) ) {
        catenary_obj = find_object("catenary", wt, catenary_obj.get_topspeed())
      }
      //gui.add_message_at(pl, " select catenary " + catenary_obj.get_name(), world.get_time())

    }

    local bridge_obj = find_object("bridge", wt, speed)
    //gui.add_message_at(pl, " select bridge " + bridge_obj.get_name(), world.get_time())

    //gui.add_message_at(pl, " bridge_stations.len() " + bridge_stations.len(), world.get_time())
    if ( speed_old < speed && bridge_stations.len() == 0 ) {
      // remove exists bridge
      local tool = command_x(tool_remove_way)
      local err = tool.work(pl, bridge_coord[0], bridge_coord[1], "" + wt)

      // build new bridge
      err = null
      err = command_x.build_bridge(pl, bridge_coord[0], bridge_coord[1], bridge_obj)

      // restore catenary
      if ( catenary_obj != null ) {
        command_x.build_wayobj(pl, catenary_coord[0], catenary_coord[1], catenary_obj)
      }

      // restore stations

    } else {
      local output_message = null
      if ( bridge_stations.len() > 0 ) {
        output_message = translate("Bridges with stations are not replaced.")
      } else {
        output_message = translate("Speed of the bridge equal to or higher than the speed of the adjacent track.")
      }
	    return gui.add_message_at(pl, output_message, world.get_time())
    }

  } else {
    local output_message = translate("The field does not belong to any bridge.")
	  return gui.add_message_at(pl, output_message, world.get_time())
  }
}

/**
  * find object tool
  *
  * obj   = object type ( bridge, tunnel, way, catenary )
  * wt    = waytype
  * speed = speed
  */
function find_object(obj, wt, speed) {

  local list = null
  switch(obj) {
    case "bridge":
      list = bridge_desc_x.get_available_bridges(wt)
      break
    case "tunnel":
      list = tunnel_desc_x.get_available_tunnels(wt)
      break
    case "way":
      list = way_desc_x.get_available_ways(wt, st_flat)
      break
    case "catenary":
      list = wayobj_desc_x.get_available_wayobjs(wt)
      break
  }

  local len = list.len()

  // sort objects by speed
  {
    local obj_list = []
    for(local i=0; i<len; i++) {
      obj_list.append(list[i].get_topspeed())
    }
    obj_list.sort()

    local sort_obj_list = []

    for(local i=0; i<len; i++) {
      //gui.add_message_at(our_player,i + " obj " + obj_list[i] , world.get_time())
      for (local j=0; j<len; j++) {
        if ( obj_list[i] == list[j].get_topspeed() ) {
          sort_obj_list.append(list[j])
        }
      }
    }
    list.clear()
    list = sort_obj_list.slice(0)
    /*for(local i=0; i<len; i++) {
      gui.add_message_at(our_player,i + " obj " + list[i].get_name() + " speed " + list[i].get_topspeed(), world.get_time())
    }*/
  }

  local max_speed = 160
  local min_len = 5

  local obj_desc = null

  if (len>0) {
    obj_desc = list[0]
    //gui.add_message_at(our_player,"0  obj_desc " + obj_desc.get_name(), world.get_time())

      for(local i=1; i<len; i++) {
        local b = list[i]
        local o = 1
        if ( obj == "bridge" && b.get_max_length() < min_len ) {
          o = 0
        }

        if ( (obj == "way" || obj == "tunnel") && !obj_desc.is_available(world.get_time()) ) {
          o = 0
        }

        if ( obj == "catenary" && !obj_desc.is_available(world.get_time()) && obj_desc.is_overhead_line() ) {
          o = 0
        }

        if ( o == 1 ) {
          if (obj_desc.get_topspeed() <= speed) {
            if ( b.get_topspeed() > obj_desc.get_topspeed() && b.get_topspeed() <= speed ) {
              obj_desc = b
              if ( obj_desc.get_topspeed() == speed ) { break }
            } else {
              if ( obj_desc.get_topspeed() >= speed ) { break }
              obj_desc = b
              //gui.add_message_at(our_player, i + " break obj_desc " + obj_desc.get_name(), world.get_time())
              break
            }
          }
        }
      }
  }

  return obj_desc
}
